package insurance;

import com.metamaxim.modelscope.callbacks.Event;
import com.metamaxim.modelscope.callbacks.Instance;
/**
 * Pays full claimed amount.
 */
public class CalculateBenefitFull extends Event{
    public void handleEvent() {
        this.log("Processing of ");
        Instance claim = this.getInstance("Claim");
        int number = claim.getInteger("Number");
        
        int amount = number * claim.getInstance("CareProcedure").getCurrency("Price");
//        int amountPaid = claim.getCurrency("Benefit Amount");
//        int amountToPay = amount - amountPaid;
        if (amount != 0) {
            Event grantBenefit = this.createEvent("Grant Benefit");
            grantBenefit.setInstance("Benefit", claim);
            grantBenefit.setCurrency("Benefit Amount", amount);
            grantBenefit.log("Created ");
            grantBenefit.submitToModel();
        }
    }
}
