package insurance.helper;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class DateUtils {
    public static int getAgeAtDate (Date birthDate, Date date) {
        Calendar cal = new GregorianCalendar();
        cal.setTime(birthDate);
        Calendar now = new GregorianCalendar();
        now.setTime(date);
        int res = now.get(Calendar.YEAR) - cal.get(Calendar.YEAR);
        if ((cal.get(Calendar.MONTH) > now.get(Calendar.MONTH)) ||
            (cal.get(Calendar.MONTH) == now.get(Calendar.MONTH) &&
             cal.get(Calendar.DAY_OF_MONTH) >
             now.get(Calendar.DAY_OF_MONTH))) {
            res--;
        }
        return res;
    }

    public static int getAge(Date birthDate) {
        Calendar cal = new GregorianCalendar();
        cal.setTime(birthDate);
        Calendar now = new GregorianCalendar();
        int res = now.get(Calendar.YEAR) - cal.get(Calendar.YEAR);
        if ((cal.get(Calendar.MONTH) > now.get(Calendar.MONTH)) ||
            (cal.get(Calendar.MONTH) == now.get(Calendar.MONTH) &&
             cal.get(Calendar.DAY_OF_MONTH) >
             now.get(Calendar.DAY_OF_MONTH))) {
            res--;
        }
        return res;
    }

    public static void main(String[] args) {
        System.out.println(addYear(new Date(),2));
    }

    public static Date addYear(Date date, int years) {
        Calendar cal = new GregorianCalendar();
        cal.setTime(date);
        cal.roll(Calendar.YEAR,years);
        cal.add(Calendar.DATE, -1);
        return cal.getTime();
    }
}
